workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" && $CI_PIPELINE_SOURCE != "merge_request_event"
      when: never
    - when: always
    
stages:
  - "test"
  - "build"
  - "deploy"

variables:
  DOCKER_USER: $DOCKER_USER
  DOCKER_PASS: $DOCKER_PASS
  IMAGE_NAME: mfardin/demo-app

build_version:
  stage: build
  tags:
    - shell
    - pc 
    - ubuntu
  script:
    - jq -r .version app/package.json > version-file.txt
  artifacts:
    paths:
      - version-file.txt

build_image:
  needs:
    - build_version
  stage: build
  tags:
    - docker
    - pc
    - ubuntu
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - echo $DOCKER_HOST
    - unset DOCKER_HOST
    - export VERSION=$(cat version-file.txt)
    - export IMAGE_TAG=app-cicd-$VERSION.$CI_PIPELINE_IID
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
  script: 
    - echo $DOCKER_PASS | docker login -u $DOCKER_USER --password-stdin
    - docker push $IMAGE_NAME:$IMAGE_TAG